// Made with Blockbench 4.11.2
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports

public class Modelbmbm<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(
			new ResourceLocation("modid", "bmbm"), "main");
	private final ModelPart Body;
	private final ModelPart Head;
	private final ModelPart Bleg;
	private final ModelPart Fleg;

	public Modelbmbm(ModelPart root) {
		this.Body = root.getChild("Body");
		this.Head = root.getChild("Head");
		this.Bleg = root.getChild("Bleg");
		this.Fleg = root.getChild("Fleg");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();

		PartDefinition Body = partdefinition.addOrReplaceChild("Body", CubeListBuilder.create(),
				PartPose.offset(-0.25F, 12.0F, 0.0F));

		PartDefinition cube_r1 = Body.addOrReplaceChild("cube_r1",
				CubeListBuilder.create().texOffs(40, 204)
						.addBox(-7.0F, -14.0F, -5.0F, 17.0F, 1.0F, 9.0F, new CubeDeformation(0.0F)).texOffs(94, 104)
						.addBox(-8.0F, -13.0F, -6.0F, 19.0F, 13.0F, 11.0F, new CubeDeformation(0.0F)).texOffs(40, 204)
						.addBox(-7.0F, 0.0F, -5.0F, 17.0F, 1.0F, 9.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 0.0F, 0.0F, -1.5708F, 0.0F));

		PartDefinition Head = partdefinition.addOrReplaceChild("Head", CubeListBuilder.create().texOffs(380, 428)
				.addBox(1.5F, -9.0F, -5.0F, 10.0F, 9.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-6.25F, 7.0F, -9.0F));

		PartDefinition cube_r2 = Head.addOrReplaceChild("cube_r2",
				CubeListBuilder.create().texOffs(63, 31).addBox(-1.0F, -2.0F, -1.0F, 2.0F, 2.0F, 2.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(6.25F, 10.25F, -4.0F, -0.0873F, 0.0F, 0.0F));

		PartDefinition cube_r3 = Head.addOrReplaceChild("cube_r3",
				CubeListBuilder.create().texOffs(10, 3).addBox(-1.0F, -2.0F, -1.0F, 2.0F, 12.0F, 2.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(6.25F, 0.0F, -5.0F, -0.0873F, 0.0F, 0.0F));

		PartDefinition cube_r4 = Head
				.addOrReplaceChild("cube_r4",
						CubeListBuilder.create().texOffs(294, 465).addBox(-5.0F, -9.0F, 0.0F, 7.0F, 9.0F, 1.0F,
								new CubeDeformation(0.0F)),
						PartPose.offsetAndRotation(0.0F, 0.0F, 0.0F, 0.0F, 0.0F, -0.0873F));

		PartDefinition cube_r5 = Head.addOrReplaceChild("cube_r5",
				CubeListBuilder.create().texOffs(242, 42)
						.addBox(0.0F, -1.0F, -2.0F, 1.0F, 1.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(242, 42)
						.addBox(-8.5F, -1.0F, -2.0F, 1.0F, 1.0F, 3.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(10.25F, 0.5F, -6.0F, 0.1745F, 0.0F, 0.0F));

		PartDefinition cube_r6 = Head.addOrReplaceChild("cube_r6",
				CubeListBuilder.create().texOffs(27, 18)
						.addBox(-1.0F, -2.0F, -1.0F, 2.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(27, 18)
						.addBox(-9.5F, -2.0F, -1.0F, 2.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(10.75F, 0.5F, -4.25F, 0.1309F, 0.0F, 0.0F));

		PartDefinition cube_r7 = Head.addOrReplaceChild("cube_r7",
				CubeListBuilder.create().texOffs(294, 465).addBox(-5.0F, -9.0F, 0.0F, 7.0F, 9.0F, 1.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(15.75F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0873F));

		PartDefinition Bleg = partdefinition.addOrReplaceChild("Bleg",
				CubeListBuilder.create().texOffs(272, 374)
						.addBox(-3.0F, 10.0F, -7.0F, 9.0F, 2.0F, 11.0F, new CubeDeformation(0.0F)).texOffs(318, 325)
						.addBox(-3.0F, 9.0F, -7.0F, 9.0F, 1.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-1.5F, 12.0F, 7.0F));

		PartDefinition cube_r8 = Bleg.addOrReplaceChild("cube_r8",
				CubeListBuilder.create().texOffs(267, 164).addBox(-2.0F, -25.0F, -4.0F, 6.0F, 13.0F, 8.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(1.5F, 22.0F, -0.5F, 0.0F, -1.5708F, 0.0F));

		PartDefinition Fleg = partdefinition.addOrReplaceChild("Fleg",
				CubeListBuilder.create().texOffs(390, 391)
						.addBox(-5.0F, 10.0F, -7.0F, 11.0F, 2.0F, 11.0F, new CubeDeformation(0.0F)).texOffs(404, 307)
						.addBox(-5.0F, 9.0F, -7.0F, 11.0F, 1.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-0.5F, 12.0F, -4.5F));

		PartDefinition cube_r9 = Fleg.addOrReplaceChild("cube_r9",
				CubeListBuilder.create().texOffs(156, 251).addBox(-3.0F, -25.0F, -5.0F, 7.0F, 13.0F, 10.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.5F, 22.0F, -0.25F, 0.0F, -1.5708F, 0.0F));

		return LayerDefinition.create(meshdefinition, 500, 500);
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay,
			float red, float green, float blue, float alpha) {
		Body.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		Head.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		Bleg.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		Fleg.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}

	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw,
			float headPitch) {
		this.Bleg.xRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
		this.Fleg.xRot = Mth.cos(limbSwing * 1.0F) * 1.0F * limbSwingAmount;
	}
}