
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.italianbrainrot.init;

import net.neoforged.neoforge.registries.DeferredRegister;
import net.neoforged.neoforge.registries.DeferredHolder;
import net.neoforged.neoforge.event.entity.EntityAttributeCreationEvent;
import net.neoforged.fml.event.lifecycle.FMLCommonSetupEvent;
import net.neoforged.fml.common.Mod;
import net.neoforged.bus.api.SubscribeEvent;

import net.minecraft.world.entity.MobCategory;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.Entity;
import net.minecraft.core.registries.Registries;

import net.mcreator.italianbrainrot.entity.TungTungTungSaurEntity;
import net.mcreator.italianbrainrot.entity.TralaleroTralalaEntity;
import net.mcreator.italianbrainrot.entity.PrrPrrPatapimEntity;
import net.mcreator.italianbrainrot.entity.LiriliLarilaEntity;
import net.mcreator.italianbrainrot.entity.CappuccinoAssassinoEntity;
import net.mcreator.italianbrainrot.entity.BombardinoCrocodiloEntity;
import net.mcreator.italianbrainrot.entity.BombEntity;
import net.mcreator.italianbrainrot.ItalianBrainrotMod;

@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD)
public class ItalianBrainrotModEntities {
	public static final DeferredRegister<EntityType<?>> REGISTRY = DeferredRegister.create(Registries.ENTITY_TYPE, ItalianBrainrotMod.MODID);
	public static final DeferredHolder<EntityType<?>, EntityType<TralaleroTralalaEntity>> TRALALERO_TRALALA = register("tralalero_tralala",
			EntityType.Builder.<TralaleroTralalaEntity>of(TralaleroTralalaEntity::new, MobCategory.CREATURE).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3)

					.sized(0.6f, 1f));
	public static final DeferredHolder<EntityType<?>, EntityType<LiriliLarilaEntity>> LIRILI_LARILA = register("lirili_larila",
			EntityType.Builder.<LiriliLarilaEntity>of(LiriliLarilaEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3)

					.sized(0.6f, 1.8f));
	public static final DeferredHolder<EntityType<?>, EntityType<TungTungTungSaurEntity>> TUNG_TUNG_TUNG_SAUR = register("tung_tung_tung_saur",
			EntityType.Builder.<TungTungTungSaurEntity>of(TungTungTungSaurEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3)

					.sized(0.6f, 1.6f));
	public static final DeferredHolder<EntityType<?>, EntityType<PrrPrrPatapimEntity>> PRR_PRR_PATAPIM = register("prr_prr_patapim",
			EntityType.Builder.<PrrPrrPatapimEntity>of(PrrPrrPatapimEntity::new, MobCategory.CREATURE).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3).fireImmune().sized(0.6f, 2.3f));
	public static final DeferredHolder<EntityType<?>, EntityType<BombardinoCrocodiloEntity>> BOMBARDINO_CROCODILO = register("bombardino_crocodilo",
			EntityType.Builder.<BombardinoCrocodiloEntity>of(BombardinoCrocodiloEntity::new, MobCategory.CREATURE).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3)

					.sized(0.6f, 1.8f));
	public static final DeferredHolder<EntityType<?>, EntityType<CappuccinoAssassinoEntity>> CAPPUCCINO_ASSASSINO = register("cappuccino_assassino",
			EntityType.Builder.<CappuccinoAssassinoEntity>of(CappuccinoAssassinoEntity::new, MobCategory.CREATURE).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3)

					.sized(0.6f, 1.8f));
	public static final DeferredHolder<EntityType<?>, EntityType<BombEntity>> BOMB = register("bomb",
			EntityType.Builder.<BombEntity>of(BombEntity::new, MobCategory.MISC).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(1).sized(0.5f, 0.5f));

	private static <T extends Entity> DeferredHolder<EntityType<?>, EntityType<T>> register(String registryname, EntityType.Builder<T> entityTypeBuilder) {
		return REGISTRY.register(registryname, () -> (EntityType<T>) entityTypeBuilder.build(registryname));
	}

	@SubscribeEvent
	public static void init(FMLCommonSetupEvent event) {
		event.enqueueWork(() -> {
			TralaleroTralalaEntity.init();
			LiriliLarilaEntity.init();
			TungTungTungSaurEntity.init();
			PrrPrrPatapimEntity.init();
			BombardinoCrocodiloEntity.init();
			CappuccinoAssassinoEntity.init();
		});
	}

	@SubscribeEvent
	public static void registerAttributes(EntityAttributeCreationEvent event) {
		event.put(TRALALERO_TRALALA.get(), TralaleroTralalaEntity.createAttributes().build());
		event.put(LIRILI_LARILA.get(), LiriliLarilaEntity.createAttributes().build());
		event.put(TUNG_TUNG_TUNG_SAUR.get(), TungTungTungSaurEntity.createAttributes().build());
		event.put(PRR_PRR_PATAPIM.get(), PrrPrrPatapimEntity.createAttributes().build());
		event.put(BOMBARDINO_CROCODILO.get(), BombardinoCrocodiloEntity.createAttributes().build());
		event.put(CAPPUCCINO_ASSASSINO.get(), CappuccinoAssassinoEntity.createAttributes().build());
	}
}
