// Made with Blockbench 4.12.4
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports

public class Modeltungsaur<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(
			new ResourceLocation("modid", "tungsaur"), "main");
	private final ModelPart Body;
	private final ModelPart rleg;
	private final ModelPart lleg;
	private final ModelPart larm;
	private final ModelPart rarm;

	public Modeltungsaur(ModelPart root) {
		this.Body = root.getChild("Body");
		this.rleg = root.getChild("rleg");
		this.lleg = root.getChild("lleg");
		this.larm = root.getChild("larm");
		this.rarm = root.getChild("rarm");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();

		PartDefinition Body = partdefinition.addOrReplaceChild("Body",
				CubeListBuilder.create().texOffs(21, 25)
						.addBox(-5.0F, -10.0F, -7.0F, 9.0F, 8.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(70, 189)
						.addBox(-5.0F, 9.0F, -5.0F, 9.0F, 2.0F, 10.0F, new CubeDeformation(0.0F)).texOffs(202, 222)
						.addBox(-5.0F, -11.0F, -5.0F, 9.0F, 2.0F, 10.0F, new CubeDeformation(0.0F)),
				PartPose.offset(1.0F, 4.0F, 0.0F));

		PartDefinition cube_r1 = Body.addOrReplaceChild("cube_r1",
				CubeListBuilder.create().texOffs(193, 1).addBox(-5.9952F, -12.2181F, -5.0F, 2.0F, 22.0F, 10.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-0.5F, 1.0F, 0.0F, 1.5708F, -1.5272F, -1.5708F));

		PartDefinition cube_r2 = Body.addOrReplaceChild("cube_r2",
				CubeListBuilder.create().texOffs(232, 0).addBox(2.9962F, -12.1745F, -5.0F, 2.0F, 22.0F, 10.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-0.5F, 1.0F, 0.5F, -1.5708F, -1.5272F, 1.5708F));

		PartDefinition cube_r3 = Body
				.addOrReplaceChild("cube_r3",
						CubeListBuilder.create().texOffs(116, 47).addBox(-1.0F, -12.0F, -5.0F, 2.0F, 22.0F, 10.0F,
								new CubeDeformation(0.0F)),
						PartPose.offsetAndRotation(4.0F, 1.0F, 0.0F, 0.0F, 0.0F, 0.0436F));

		PartDefinition cube_r4 = Body.addOrReplaceChild("cube_r4",
				CubeListBuilder.create().texOffs(77, 48).addBox(-1.0F, -12.0F, -5.0F, 2.0F, 22.0F, 10.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-5.0F, 1.0F, 0.0F, 0.0F, 0.0F, -0.0436F));

		PartDefinition rleg = partdefinition.addOrReplaceChild("rleg",
				CubeListBuilder.create().texOffs(40, 102)
						.addBox(-1.0F, 0.0F, 1.0F, 3.0F, 9.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(12, 69)
						.addBox(-2.0F, 8.0F, -2.0F, 5.0F, 1.0F, 3.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-3.0F, 15.0F, -2.0F));

		PartDefinition lleg = partdefinition.addOrReplaceChild("lleg",
				CubeListBuilder.create().texOffs(40, 102)
						.addBox(-2.0F, 0.0F, 1.0F, 3.0F, 9.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(12, 69)
						.addBox(-3.0F, 8.0F, -2.0F, 5.0F, 1.0F, 3.0F, new CubeDeformation(0.0F)),
				PartPose.offset(4.0F, 15.0F, -2.0F));

		PartDefinition larm = partdefinition.addOrReplaceChild("larm", CubeListBuilder.create(),
				PartPose.offset(7.0F, 4.0F, 0.0F));

		PartDefinition cube_r5 = larm
				.addOrReplaceChild("cube_r5",
						CubeListBuilder.create().texOffs(186, 138).addBox(-1.0F, -2.0F, -1.0F, 2.0F, 10.0F, 2.0F,
								new CubeDeformation(0.0F)),
						PartPose.offsetAndRotation(0.0F, 1.0F, 0.0F, 0.0F, 0.0F, -0.0873F));

		PartDefinition rarm = partdefinition.addOrReplaceChild("rarm", CubeListBuilder.create().texOffs(107, 7).addBox(
				-2.0F, 7.0F, -11.0F, 2.0F, 2.0F, 12.0F, new CubeDeformation(0.0F)), PartPose.offset(-5.5F, 4.0F, 0.5F));

		PartDefinition cube_r6 = rarm.addOrReplaceChild("cube_r6",
				CubeListBuilder.create().texOffs(186, 138).addBox(-1.0F, -2.0F, -1.0F, 2.0F, 10.0F, 2.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-0.5F, 1.0F, -0.5F, 0.0F, 0.0F, 0.0873F));

		return LayerDefinition.create(meshdefinition, 256, 256);
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay,
			float red, float green, float blue, float alpha) {
		Body.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		rleg.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		lleg.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		larm.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		rarm.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}

	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw,
			float headPitch) {
		this.lleg.xRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
		this.larm.xRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
		this.rleg.xRot = Mth.cos(limbSwing * 1.0F) * 1.0F * limbSwingAmount;
		this.rarm.xRot = Mth.cos(limbSwing * 0.6662F + (float) Math.PI) * limbSwingAmount;
	}
}