package net.mcreator.italianbrainrot.client.model;

import net.minecraft.world.entity.Entity;
import net.minecraft.util.Mth;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.model.geom.builders.PartDefinition;
import net.minecraft.client.model.geom.builders.MeshDefinition;
import net.minecraft.client.model.geom.builders.LayerDefinition;
import net.minecraft.client.model.geom.builders.CubeListBuilder;
import net.minecraft.client.model.geom.builders.CubeDeformation;
import net.minecraft.client.model.geom.PartPose;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.geom.ModelLayerLocation;
import net.minecraft.client.model.EntityModel;

import com.mojang.blaze3d.vertex.VertexConsumer;
import com.mojang.blaze3d.vertex.PoseStack;

// Made with Blockbench 4.11.2
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports
public class Modeltralalerotralala<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(new ResourceLocation("italian_brainrot", "modeltralalerotralala"), "main");
	public final ModelPart Tail;
	public final ModelPart Body;
	public final ModelPart RightLeg;
	public final ModelPart LeftLeg;
	public final ModelPart rdLeg;
	public final ModelPart Spine;

	public Modeltralalerotralala(ModelPart root) {
		this.Tail = root.getChild("Tail");
		this.Body = root.getChild("Body");
		this.RightLeg = root.getChild("RightLeg");
		this.LeftLeg = root.getChild("LeftLeg");
		this.rdLeg = root.getChild("rdLeg");
		this.Spine = root.getChild("Spine");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();
		PartDefinition Tail = partdefinition.addOrReplaceChild("Tail",
				CubeListBuilder.create().texOffs(1, 1).addBox(-1.0F, 2.5F, 5.0F, 2.0F, 2.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(1, 1).addBox(-1.0F, -9.5F, 5.0F, 2.0F, 9.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(50, 104)
						.addBox(-0.5F, -7.5F, 3.0F, 1.0F, 11.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(214, 75).addBox(-1.0F, -2.0F, 0.0F, 2.0F, 4.0F, 3.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, 16.5F, 10.0F));
		PartDefinition Body = partdefinition
				.addOrReplaceChild(
						"Body", CubeListBuilder.create().texOffs(1, 1).addBox(-4.5F, -5.0F, -3.25F, 9.0F, 7.0F, 10.0F, new CubeDeformation(0.0F)).texOffs(179, 27).addBox(-3.5F, -4.5F, 6.75F, 7.0F, 6.0F, 7.0F, new CubeDeformation(0.0F))
								.texOffs(91, 154).addBox(-4.0F, -4.5F, -9.25F, 8.0F, 6.0F, 6.0F, new CubeDeformation(0.0F)).texOffs(114, 212).addBox(-4.0F, -3.0F, -15.0F, 8.0F, 3.0F, 7.0F, new CubeDeformation(0.0F)),
						PartPose.offset(0.0F, 17.0F, -3.75F));
		PartDefinition cube_r1 = Body.addOrReplaceChild("cube_r1", CubeListBuilder.create().texOffs(215, 228).addBox(-4.0F, -2.0F, -4.0F, 7.0F, 2.0F, 5.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.5F, 1.25F, -10.25F, -0.2182F, 0.0F, 0.0F));
		PartDefinition cube_r2 = Body.addOrReplaceChild("cube_r2", CubeListBuilder.create().texOffs(23, 215).addBox(-3.0F, 2.0F, -5.0F, 7.0F, 2.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-0.5F, -6.25F, -10.25F, 0.2618F, 0.0F, 0.0F));
		PartDefinition RightLeg = partdefinition.addOrReplaceChild("RightLeg",
				CubeListBuilder.create().texOffs(210, 151).addBox(-5.0F, 5.0F, -2.0F, 4.0F, 1.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(180, 162).addBox(-5.0F, 6.0F, -5.0F, 4.0F, 2.0F, 8.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-4.0F, 16.0F, -4.0F));
		PartDefinition cube_r3 = RightLeg.addOrReplaceChild("cube_r3", CubeListBuilder.create().texOffs(162, 101).addBox(-1.0F, -7.0F, -1.0F, 2.0F, 6.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-3.0F, 6.0F, 0.0F, 0.0F, 0.0F, 0.48F));
		PartDefinition LeftLeg = partdefinition.addOrReplaceChild("LeftLeg",
				CubeListBuilder.create().texOffs(210, 151).addBox(1.0F, 5.0F, -2.0F, 4.0F, 1.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(180, 162).addBox(1.0F, 6.0F, -5.0F, 4.0F, 2.0F, 8.0F, new CubeDeformation(0.0F)),
				PartPose.offset(4.0F, 16.0F, -4.0F));
		PartDefinition LeftLeg_r1 = LeftLeg.addOrReplaceChild("LeftLeg_r1", CubeListBuilder.create().texOffs(140, 98).addBox(-1.0F, -7.0F, -1.0F, 2.0F, 6.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(3.0F, 6.0F, 0.0F, 0.0F, 0.0F, -0.48F));
		PartDefinition rdLeg = partdefinition.addOrReplaceChild("rdLeg", CubeListBuilder.create().texOffs(130, 123).addBox(-1.0F, 0.0F, -1.0F, 2.0F, 3.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(180, 162)
				.addBox(-2.0F, 4.0F, -5.0F, 4.0F, 2.0F, 8.0F, new CubeDeformation(0.0F)).texOffs(210, 151).addBox(-2.0F, 3.0F, -2.0F, 4.0F, 1.0F, 4.0F, new CubeDeformation(0.0F)), PartPose.offset(0.0F, 18.0F, 7.0F));
		PartDefinition Spine = partdefinition.addOrReplaceChild("Spine", CubeListBuilder.create(), PartPose.offset(0.0F, 12.5F, -3.25F));
		PartDefinition cube_r4 = Spine.addOrReplaceChild("cube_r4", CubeListBuilder.create().texOffs(142, 16).addBox(-1.0F, -2.0F, -1.0F, 2.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, -4.0F, 2.0F, -0.2618F, 0.0F, 0.0F));
		PartDefinition cube_r5 = Spine.addOrReplaceChild("cube_r5", CubeListBuilder.create().texOffs(68, 41).addBox(-1.0F, -2.0F, -3.0F, 2.0F, 2.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, -2.0F, 1.75F, -0.2182F, 0.0F, 0.0F));
		PartDefinition cube_r6 = Spine.addOrReplaceChild("cube_r6", CubeListBuilder.create().texOffs(20, 104).addBox(-1.0F, -3.0F, -5.0F, 2.0F, 3.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 1.0F, 1.75F, -0.1745F, 0.0F, 0.0F));
		return LayerDefinition.create(meshdefinition, 256, 256);
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay, float red, float green, float blue, float alpha) {
		Tail.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		Body.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		RightLeg.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		LeftLeg.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		rdLeg.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		Spine.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}

	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
		this.LeftLeg.xRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
		this.RightLeg.xRot = Mth.cos(limbSwing * 1.0F) * 1.0F * limbSwingAmount;
	}
}
