package net.mcreator.italianbrainrot.client.model;

import net.minecraft.world.entity.Entity;
import net.minecraft.util.Mth;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.model.geom.builders.PartDefinition;
import net.minecraft.client.model.geom.builders.MeshDefinition;
import net.minecraft.client.model.geom.builders.LayerDefinition;
import net.minecraft.client.model.geom.builders.CubeListBuilder;
import net.minecraft.client.model.geom.builders.CubeDeformation;
import net.minecraft.client.model.geom.PartPose;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.geom.ModelLayerLocation;
import net.minecraft.client.model.EntityModel;

import com.mojang.blaze3d.vertex.VertexConsumer;
import com.mojang.blaze3d.vertex.PoseStack;

// Made with Blockbench 4.12.4
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports
public class Modeltt<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(new ResourceLocation("italian_brainrot", "modeltt"), "main");
	public final ModelPart leg;
	public final ModelPart legg;
	public final ModelPart leggg;
	public final ModelPart legggg;
	public final ModelPart Body;

	public Modeltt(ModelPart root) {
		this.leg = root.getChild("leg");
		this.legg = root.getChild("legg");
		this.leggg = root.getChild("leggg");
		this.legggg = root.getChild("legggg");
		this.Body = root.getChild("Body");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();
		PartDefinition leg = partdefinition.addOrReplaceChild("leg", CubeListBuilder.create(), PartPose.offset(-3.0F, 20.0F, 4.0F));
		PartDefinition cube_r1 = leg.addOrReplaceChild("cube_r1", CubeListBuilder.create().texOffs(195, 86).addBox(-1.0F, -4.0F, -1.0F, 1.0F, 4.0F, 2.0F, new CubeDeformation(0.0F)), PartPose.offsetAndRotation(0.5F, 4.0F, 0.0F, 0.0F, -0.1309F, 0.0F));
		PartDefinition legg = partdefinition.addOrReplaceChild("legg", CubeListBuilder.create(), PartPose.offset(3.0F, 20.0F, 4.0F));
		PartDefinition cube_r2 = legg.addOrReplaceChild("cube_r2", CubeListBuilder.create().texOffs(195, 86).addBox(-1.0F, -4.0F, -1.0F, 1.0F, 4.0F, 2.0F, new CubeDeformation(0.0F)), PartPose.offsetAndRotation(0.5F, 4.0F, 0.0F, 0.0F, 0.1309F, 0.0F));
		PartDefinition leggg = partdefinition.addOrReplaceChild("leggg", CubeListBuilder.create(), PartPose.offset(2.0F, 20.0F, -4.0F));
		PartDefinition cube_r3 = leggg.addOrReplaceChild("cube_r3", CubeListBuilder.create().texOffs(195, 86).addBox(-1.0F, -4.0F, -1.0F, 1.0F, 4.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.5F, 4.0F, 0.0F, 0.0F, 0.0873F, 0.0F));
		PartDefinition legggg = partdefinition.addOrReplaceChild("legggg", CubeListBuilder.create(), PartPose.offset(-2.0F, 20.0F, -4.0F));
		PartDefinition cube_r4 = legggg.addOrReplaceChild("cube_r4", CubeListBuilder.create().texOffs(195, 86).addBox(-1.0F, -4.0F, -1.0F, 1.0F, 4.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.5F, 4.0F, 0.0F, 0.0F, -0.0873F, 0.0F));
		PartDefinition Body = partdefinition.addOrReplaceChild("Body",
				CubeListBuilder.create().texOffs(27, 19).addBox(-4.0F, -2.75F, -5.25F, 8.0F, 5.0F, 10.0F, new CubeDeformation(0.0F)).texOffs(122, 77).addBox(-3.0F, -3.5F, 5.25F, 6.0F, 6.0F, 6.0F, new CubeDeformation(0.0F)).texOffs(1, 0)
						.addBox(0.0F, -4.25F, -11.25F, 0.0F, 7.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(110, 167).addBox(-3.0F, -2.25F, -6.75F, 6.0F, 4.0F, 12.0F, new CubeDeformation(0.0F)).texOffs(107, 49)
						.addBox(-1.5F, 0.0F, 10.0F, 3.0F, 1.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, 17.75F, 0.25F));
		PartDefinition cube_r5 = Body.addOrReplaceChild("cube_r5", CubeListBuilder.create().texOffs(111, 13).addBox(0.0F, -2.0F, -4.0F, 0.0F, 2.0F, 8.0F, new CubeDeformation(0.0F)), PartPose.offsetAndRotation(0.0F, -2.0F, 0.0F, 0.1309F, 0.0F, 0.0F));
		PartDefinition cube_r6 = Body.addOrReplaceChild("cube_r6",
				CubeListBuilder.create().texOffs(221, 62).addBox(-1.0F, -2.0F, -1.0F, 1.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(221, 62).addBox(3.0F, -2.0F, -1.0F, 1.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-1.5F, -2.75F, 8.25F, 0.1309F, 0.0F, 0.0F));
		PartDefinition cube_r7 = Body.addOrReplaceChild("cube_r7", CubeListBuilder.create().texOffs(203, 26).addBox(-2.0F, -2.0F, -2.0F, 4.0F, 3.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.25F, -7.0F, 0.0F, 0.7854F, 0.0F));
		return LayerDefinition.create(meshdefinition, 256, 256);
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay, float red, float green, float blue, float alpha) {
		leg.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		legg.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		leggg.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		legggg.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		Body.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}

	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
		this.legggg.xRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
		this.legg.xRot = Mth.cos(limbSwing * 1.0F) * 1.0F * limbSwingAmount;
		this.leg.xRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
		this.leggg.xRot = Mth.cos(limbSwing * 1.0F) * 1.0F * limbSwingAmount;
	}
}
