package net.mcreator.italianbrainrot.client.model;

import net.minecraft.world.entity.Entity;
import net.minecraft.util.Mth;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.model.geom.builders.PartDefinition;
import net.minecraft.client.model.geom.builders.MeshDefinition;
import net.minecraft.client.model.geom.builders.LayerDefinition;
import net.minecraft.client.model.geom.builders.CubeListBuilder;
import net.minecraft.client.model.geom.builders.CubeDeformation;
import net.minecraft.client.model.geom.PartPose;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.geom.ModelLayerLocation;
import net.minecraft.client.model.EntityModel;

import com.mojang.blaze3d.vertex.VertexConsumer;
import com.mojang.blaze3d.vertex.PoseStack;

// Made with Blockbench 4.12.4
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports
public class Modelvacca<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(new ResourceLocation("italian_brainrot", "modelvacca"), "main");
	public final ModelPart Rleg;
	public final ModelPart Lleg;
	public final ModelPart Head;
	public final ModelPart Rarm;
	public final ModelPart Larm;

	public Modelvacca(ModelPart root) {
		this.Rleg = root.getChild("Rleg");
		this.Lleg = root.getChild("Lleg");
		this.Head = root.getChild("Head");
		this.Rarm = root.getChild("Rarm");
		this.Larm = root.getChild("Larm");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();
		PartDefinition Rleg = partdefinition.addOrReplaceChild("Rleg", CubeListBuilder.create(), PartPose.offset(-9.0F, -9.0F, -2.0F));
		PartDefinition cube_r1 = Rleg.addOrReplaceChild("cube_r1", CubeListBuilder.create().texOffs(92, 39).addBox(-8.0F, -4.0F, -10.0F, 14.0F, 4.0F, 20.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-1.0F, 33.0F, 0.0F, 0.0F, 0.1309F, 0.0F));
		PartDefinition cube_r2 = Rleg.addOrReplaceChild("cube_r2", CubeListBuilder.create().texOffs(58, 207).addBox(-4.0F, -24.0F, -5.0F, 9.0F, 33.0F, 7.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-1.0F, 20.25F, 5.0F, 0.0F, 0.0F, 0.0873F));
		PartDefinition Lleg = partdefinition.addOrReplaceChild("Lleg", CubeListBuilder.create(), PartPose.offset(9.0F, -8.0F, 1.0F));
		PartDefinition cube_r3 = Lleg.addOrReplaceChild("cube_r3", CubeListBuilder.create().texOffs(92, 39).addBox(-8.0F, -4.0F, -10.0F, 14.0F, 4.0F, 20.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(3.0F, 32.0F, -3.0F, 0.0F, -0.1309F, 0.0F));
		PartDefinition cube_r4 = Lleg.addOrReplaceChild("cube_r4", CubeListBuilder.create().texOffs(58, 207).addBox(-4.0F, -24.0F, -5.0F, 9.0F, 33.0F, 7.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 19.25F, 2.0F, 0.0F, 0.0F, -0.0873F));
		PartDefinition Head = partdefinition.addOrReplaceChild("Head",
				CubeListBuilder.create().texOffs(197, 20).addBox(-6.5F, -7.0F, -5.0F, 14.0F, 15.0F, 12.0F, new CubeDeformation(0.0F)).texOffs(194, 81).addBox(-7.5F, 3.0F, -6.0F, 16.0F, 6.0F, 12.0F, new CubeDeformation(0.0F)).texOffs(0, 60)
						.addBox(4.5F, -6.0F, -6.0F, 4.0F, 9.0F, 12.0F, new CubeDeformation(0.0F)).texOffs(0, 60).addBox(-7.5F, -6.0F, -6.0F, 4.0F, 9.0F, 12.0F, new CubeDeformation(0.0F)).texOffs(172, 232)
						.addBox(-8.0F, -10.0F, -7.0F, 18.0F, 5.0F, 11.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-0.5F, -10.0F, 0.0F));
		PartDefinition cube_r5 = Head.addOrReplaceChild("cube_r5", CubeListBuilder.create().texOffs(105, 135).addBox(-9.0F, -2.0F, 0.0F, 18.0F, 18.0F, 10.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.5F, -6.0F, -2.0F, 0.48F, 0.0F, 0.0F));
		PartDefinition cube_r6 = Head.addOrReplaceChild("cube_r6", CubeListBuilder.create().texOffs(21, 19).addBox(-2.0F, -4.0F, -5.0F, 4.0F, 10.0F, 4.0F, new CubeDeformation(0.0F)), PartPose.offsetAndRotation(0.5F, 5.0F, -2.5F, -0.48F, 0.0F, 0.0F));
		PartDefinition Rarm = partdefinition.addOrReplaceChild("Rarm", CubeListBuilder.create(), PartPose.offset(-13.0F, -9.0F, 1.0F));
		PartDefinition Rarm_r1 = Rarm.addOrReplaceChild("Rarm_r1", CubeListBuilder.create().texOffs(27, 142).addBox(-1.0F, -2.0F, -1.0F, 3.0F, 14.0F, 3.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.2182F));
		PartDefinition Larm = partdefinition.addOrReplaceChild("Larm", CubeListBuilder.create(), PartPose.offset(13.0F, -9.0F, 1.0F));
		PartDefinition cube_r7 = Larm.addOrReplaceChild("cube_r7", CubeListBuilder.create().texOffs(27, 142).addBox(-1.0F, -2.0F, -1.0F, 3.0F, 14.0F, 3.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 0.0F, 0.0F, 0.0F, -0.1309F));
		return LayerDefinition.create(meshdefinition, 256, 256);
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay, float red, float green, float blue, float alpha) {
		Rleg.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		Lleg.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		Head.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		Rarm.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		Larm.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}

	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
		this.Head.yRot = netHeadYaw / (180F / (float) Math.PI);
		this.Head.xRot = headPitch / (180F / (float) Math.PI);
		this.Larm.xRot = Mth.cos(limbSwing * 0.6662F) * limbSwingAmount;
		this.Lleg.xRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
		this.Rleg.xRot = Mth.cos(limbSwing * 1.0F) * 1.0F * limbSwingAmount;
		this.Rarm.xRot = Mth.cos(limbSwing * 0.6662F + (float) Math.PI) * limbSwingAmount;
	}
}
